# KubeVirt metrics

This document aims to help users that are not familiar with all metrics exposed by different KubeVirt components.
All metrics documented here are auto-generated by the utility tool`tools/doc-generator` and reflects exactly what is being exposed.

## KubeVirt-specific metrics

### kubevirt_info
Version information.

## VMI metrics

### kubevirt_vmi_memory_available_bytes
#### HELP kubevirt_vmi_memory_available_bytes amount of usable memory as seen by the domain.
Amount of `usable` memory as seen by the domain.

### kubevirt_vmi_memory_resident_bytes
#### HELP kubevirt_vmi_memory_resident_bytes resident set size of the process running the domain.
Resident set size of the process running the domain.

### kubevirt_vmi_memory_unused_bytes
#### HELP kubevirt_vmi_memory_unused_bytes amount of unused memory as seen by the domain.
Amount of `unused` memory as seen by the domain.

### kubevirt_vmi_phase_count
Sum of VMIs per phase and node.<br/>`phase` can be one of the following: [`Pending`, `Scheduling`, `Scheduled`, `Running`, `Succeeded`, `Failed`, `Unknown`]

### kubevirt_vmi_vcpu_seconds
#### HELP kubevirt_vmi_vcpu_seconds Vcpu elapsed time.
Amount of time spent in each state by each vcpu.<br/>Where `id` is the vcpu identifier and `state` can be one of the following: [`OFFLINE`, `RUNNING`, `BLOCKED`]

### kubevirt_vmi_vcpu_wait_seconds
#### HELP kubevirt_vmi_vcpu_wait_seconds vcpu time spent by waiting on I/O.
Amount of time spent by each vcpu while waiting on I/O

### kubevirt_vmi_outdated_count
#### HELP kubevirt_vmi_outdated_count Indication for the number of VirtualMachineInstance workloads that are not running within the most up-to-date version of the virt-launcher environment.
Indication for the number of VirtualMachineInstance workloads that are not running within the most up-to-date version of the virt-launcher environment.

### kubevirt_vmi_network_receive_bytes_total
#### HELP kubevirt_vmi_network_receive_bytes_total Network traffic receive in bytes
Network traffic receive in bytes

### kubevirt_vmi_network_receive_errors_total
#### HELP kubevirt_vmi_network_receive_errors_total Network receive error packets
Network receive error packets

### kubevirt_vmi_network_receive_packets_dropped_total
#### HELP kubevirt_vmi_network_receive_packets_dropped_total The number of rx packets dropped on vNIC interfaces.
The number of rx packets dropped on vNIC interfaces.

### kubevirt_vmi_network_receive_packets_total
#### HELP kubevirt_vmi_network_receive_packets_total Network traffic receive packets
Network traffic receive packets

### kubevirt_vmi_network_transmit_bytes_total
#### HELP kubevirt_vmi_network_transmit_bytes_total Network traffic transmit in bytes
Network traffic transmit in bytes

### kubevirt_vmi_network_transmit_errors_total
#### HELP kubevirt_vmi_network_transmit_errors_total Network transmit error packets
Network transmit error packets

### kubevirt_vmi_network_transmit_packets_dropped_total
#### HELP kubevirt_vmi_network_transmit_packets_dropped_total The number of tx packets dropped on vNIC interfaces.
The number of tx packets dropped on vNIC interfaces.

### kubevirt_vmi_network_transmit_packets_total
#### HELP kubevirt_vmi_network_transmit_packets_total Network traffic transmit packets
Network traffic transmit packets

### kubevirt_vmi_memory_actual_balloon_bytes
#### HELP kubevirt_vmi_memory_actual_balloon_bytes current balloon bytes.
Current balloon bytes.

### kubevirt_vmi_memory_pgmajfault
#### HELP kubevirt_vmi_memory_pgmajfault The number of page faults when disk IO was required.
The number of page faults when disk IO was required.

### kubevirt_vmi_memory_pgminfault
#### HELP kubevirt_vmi_memory_pgminfault The number of other page faults, when disk IO was not required.
The number of other page faults, when disk IO was not required.

### kubevirt_vmi_memory_swap_in_traffic_bytes_total
#### HELP kubevirt_vmi_memory_swap_in_traffic_bytes_total Swap in memory traffic in bytes
Swap in memory traffic in bytes

### kubevirt_vmi_memory_swap_out_traffic_bytes_total
#### HELP kubevirt_vmi_memory_swap_out_traffic_bytes_total Swap out memory traffic in bytes
Swap out memory traffic in bytes

### kubevirt_vmi_memory_usable_bytes
#### HELP kubevirt_vmi_memory_usable_bytes The amount of memory which can be reclaimed by balloon without causing host swapping in bytes.
The amount of memory which can be reclaimed by balloon without causing host swapping in bytes.

### kubevirt_vmi_memory_used_total_bytes
#### HELP kubevirt_vmi_memory_used_total_bytes The amount of memory in bytes used by the domain.
The amount of memory in bytes used by the domain.

### kubevirt_vmi_cpu_affinity
#### HELP kubevirt_vmi_cpu_affinity vcpu affinity details
The vcpu affinity details

### kubevirt_vmi_storage_flush_requests_total
#### HELP kubevirt_vmi_storage_flush_requests_total storage flush requests.
Storage flush requests.

### kubevirt_vmi_storage_flush_times_ms_total
#### HELP kubevirt_vmi_storage_flush_times_ms_total total time (ms) spent on cache flushing.
Total time (ms) spent on cache flushing.

### kubevirt_vmi_storage_iops_read_total
#### HELP kubevirt_vmi_storage_iops_read_total I/O read operations
I/O read operations

### kubevirt_vmi_storage_iops_write_total
#### HELP kubevirt_vmi_storage_iops_write_total I/O write operations
I/O write operations

### kubevirt_vmi_storage_read_times_ms_total
#### HELP kubevirt_vmi_storage_read_times_ms_total Storage read operation time
Storage read operation time

### kubevirt_vmi_storage_read_traffic_bytes_total
#### HELP kubevirt_vmi_storage_read_traffic_bytes_total Storage read traffic in bytes
Storage read traffic in bytes

### kubevirt_vmi_storage_write_times_ms_total
#### HELP kubevirt_vmi_storage_write_times_ms_total Storage write operation time
Storage write operation time

### kubevirt_vmi_storage_write_traffic_bytes_total
#### HELP kubevirt_vmi_storage_write_traffic_bytes_total Storage write traffic in bytes
Storage write traffic in bytes

### kubevirt_vmi_network_traffic_bytes_total
#### HELP kubevirt_vmi_network_traffic_bytes_total network traffic.
Deprecated.

## Virt Operator metrics

### kubevirt_virt_controller_leading_total
#### HELP kubevirt_virt_controller_leading Indication for an operating virt-controller.
Indication for an operating virt-controller.

### kubevirt_virt_controller_ready_total
#### HELP kubevirt_virt_controller_ready Indication for a virt-controller that is ready to take the lead.
Indication for a virt-controller that is ready to take the lead.

# Developing new metrics

After developing new metrics or changing old ones, please run `make generate` to regenerate this document.

If you feel that the new metric doesn't follow these rules, please change `doc-generator` with your needs.
